// Copyright (c) Renewed Vision, LLC. All rights reserved.

uniform sampler2DRect texUnitY;

void main()
{
    vec4 tmp0;
    vec4 tmp1;
    vec4 tmp2;
    vec4 tmp3;
    float isOddLine;
    float isOddUV;
    vec2 tc00;
    vec2 tc10;
    vec2 tc20;
    vec2 tc30;
    vec4 c00;
    vec4 c10;
    vec4 c20;
    vec4 c30;
    vec4 avg;
    float min1;
    float min2;
    float max1;
    float max2;
    float gray0;
    float gray1;
    float gray2;
    float gray3;
    
    tc10=gl_TexCoord[0].xy;
    
    isOddLine=floor(fract(tc10.y * 0.5) * 2.0);
    isOddUV = floor(fract(tc10.x * 0.5) * 2.0);
    tc10.x*=.5;
    
    //above and below lines start with same coordinates
    tc00=tc10;
    tc20=tc10;
    tc30=tc10;
    //for above line, subtract 1
    tc00.y-=isOddLine;
    //for below line, add 1
    tc20.y+=isOddLine;
    tc30.y
    
    c00 = texture2DRect(texUnitY, tc00);
    c10 = texture2DRect(texUnitY, tc10);
    c20 = texture2DRect(texUnitY, tc20);
    c30 = texture2DRect(texUnitY, tc30);

    tmp0=c00;
    tmp1=c10;
    tmp2=c20;
    tmp3=c30;

    tmp0.g=c00.a;
    tmp1.g=c10.a;
    tmp2.g=c20.a;
    tmp3.g=c30.a;

    c00=mix(c00,tmp0,isOddUV);
    c10=mix(c10,tmp1,isOddUV);
    c20=mix(c20,tmp2,isOddUV);
    c30=mix(c30,tmp3,isOddUV);

    avg=(c00+c20)*0.5;
    
    min1=c00.g*0.9;
    min2=c20.g*0.9;
    max1=c20.g*1.1;
    max2=c00.g*1.1;
    
    if(((c10.g>=min1)&&(c10.g<=max1))||((c10.g<=max2)&&(c10.g>=min2)))
    {
        gl_FragData[0]=c10;
    }
    else
    {
        gl_FragData[0]=avg;
    }
    avg=(c10+c30)*0.5;
    
    min1=c10.g*0.9;
    min2=c20.g*0.9;
    max1=c20.g*1.1;
    max2=c10.g*1.1;
    
    if(((c20.g>=min1)&&(c20.g<=max1))||((c20.g<=max2)&&(c20.g>=min2)))
    {
        gl_FragData[1]=c20;
    }
    else
    {
        gl_FragData[1]=avg;
    }
}
