// Copyright (c) Renewed Vision, LLC. All rights reserved.

uniform sampler2DRect texUnitY;
uniform sampler2DRect texUnitU;
uniform sampler2DRect texUnitV;
uniform vec4 gamma;

void main()
{
    vec4 y;
    vec4 u;
    vec4 v;
    vec4 outPixel;
    vec2 tcY=gl_TexCoord[0].xy;
    vec2 tcUV=tcY;
    tcUV.x*=.5;

    y = texture2DRect(texUnitY, tcY);
    u = texture2DRect(texUnitU, tcUV);
    v = texture2DRect(texUnitV, tcUV);

    outPixel.a=1.0;
    outPixel.r=y.b;
    outPixel.g=u.b;
    outPixel.b=v.b;
    gl_FragColor=outPixel;
}
