// Copyright (c) Renewed Vision, LLC. All rights reserved.
// Convert (horizontal downsample) YUV444 to YUV422

uniform sampler2DRect inputTex;
uniform float xInc;

void main()
{
    vec4 yuv0;
    vec4 yuv1;
    vec2 tc0=gl_TexCoord[0].xy;
    
    yuv0 = texture2DRect(inputTex, tc0);
    tc0.x+=xInc;
    yuv1 = texture2DRect(inputTex, tc0);
    
    gl_FragColor=mix(yuv0,yuv1,.5);
    gl_FragColor.a = yuv1.g;
    gl_FragColor.g = yuv0.g;
}
