// Copyright (c) Renewed Vision, LLC. All rights reserved.

uniform sampler2DRect inputTex;

const vec4 std601R = vec4(1.4022 ,  1.164 ,   0.0  ,0.0  );
const vec4 std601G = vec4(-0.813,  1.164 , -0.391  ,0.0  );
const vec4 std601B = vec4(   0.0, 1.164 ,   2.018  ,0.0  );
const vec4 stdbias = vec4(-0.5  , -0.0625,  -0.5   ,0.0  );

void main()
{
    vec4 texColor0;
    vec4 texColor1;
    float isOddUV;
    vec2 tc0=gl_TexCoord[0].xy;

    texColor0 = texture2DRect(inputTex, tc0);

    texColor0+=stdbias;
    gl_FragColor = vec4(dot(std601R, texColor0),
                    dot(std601G, texColor0),
                    dot(std601B, texColor0),
                    1.0 );
}
